import RPi.GPIO as GPIO
import time
import random

#----------------------------------------------------------

def Initialize():

	global LEDValues
	global GameState
	global StateCounter
	global GamePlay
	global ChoiceRed
	global ChoiceGreen
	global GameResult
	global LEDResultState
	global LEDResultStateGreen
	global LEDResultStateRed
	global ResultToggleCounter

	GPIO.setmode(GPIO.BOARD)

	GPIO.setup(LED_GREEN_SCISSORS, GPIO.OUT)
	GPIO.setup(LED_GREEN_PAPER, GPIO.OUT)
	GPIO.setup(LED_GREEN_STONE, GPIO.OUT)

	GPIO.setup(LED_RED_SCISSORS, GPIO.OUT)
	GPIO.setup(LED_RED_PAPER, GPIO.OUT)
	GPIO.setup(LED_RED_STONE, GPIO.OUT)

	GPIO.setup(LED_GREEN_RESULT, GPIO.OUT)
	GPIO.setup(LED_RED_RESULT, GPIO.OUT)

	GPIO.setup(SWITCH_GREEN_SCISSORS, GPIO.IN)
	GPIO.setup(SWITCH_GREEN_PAPER, GPIO.IN)
	GPIO.setup(SWITCH_GREEN_STONE, GPIO.IN)

	GPIO.setup(SWITCH_RED_SCISSORS, GPIO.IN)
	GPIO.setup(SWITCH_RED_PAPER, GPIO.IN)
	GPIO.setup(SWITCH_RED_STONE, GPIO.IN)

	GPIO.setup(SWITCH_PLAY, GPIO.IN)

#----------------------------------------------------------

def Get_Inputs():

	global LEDValues
	global GameState
	global StateCounter
	global GamePlay
	global ChoiceRed
	global ChoiceGreen
	global GameResult
	global LEDResultState
	global LEDResultStateGreen
	global LEDResultStateRed
	global ResultToggleCounter

	if (GameState == STATE_INITIAL):
		GamePlay = False
		if (not GPIO.input(SWITCH_PLAY)):
			Delay_ms(5)
			if (not GPIO.input(SWITCH_PLAY)):
				GamePlay = True

#	elif (GameState == STATE_START):

	elif (GameState == STATE_PLAY):
		if (StateCounter == 0):
			ChoiceCount = 0
			if (not GPIO.input(SWITCH_GREEN_SCISSORS)):
				ChoiceGreen = CHOICE_SCISSORS
				ChoiceCount+= 1
			if (not GPIO.input(SWITCH_GREEN_PAPER)):
				ChoiceGreen = CHOICE_PAPER
				ChoiceCount+= 1
			if (not GPIO.input(SWITCH_GREEN_STONE)):
				ChoiceGreen = CHOICE_STONE
				ChoiceCount+= 1
			if (ChoiceCount != 1):
				ChoiceGreen = CHOICE_INVALID

			ChoiceCount = 0
			if (not GPIO.input(SWITCH_RED_SCISSORS)):
				ChoiceRed = CHOICE_SCISSORS
				ChoiceCount+= 1
			if (not GPIO.input(SWITCH_RED_PAPER)):
				ChoiceRed = CHOICE_PAPER
				ChoiceCount+= 1
			if (not GPIO.input(SWITCH_RED_STONE)):
				ChoiceRed = CHOICE_STONE
				ChoiceCount+= 1
			if (ChoiceCount != 1):
				ChoiceRed = CHOICE_INVALID

	elif (GameState == STATE_RESULT):
		GamePlay = False
		if (not GPIO.input(SWITCH_PLAY)):
			Delay_ms(5)
			if (not GPIO.input(SWITCH_PLAY)):
				GamePlay = True

#----------------------------------------------------------

def Decide():

	global LEDValues
	global GameState
	global StateCounter
	global GamePlay
	global ChoiceRed
	global ChoiceGreen
	global GameResult
	global LEDResultState
	global LEDResultStateGreen
	global LEDResultStateRed
	global ResultToggleCounter

	if (GameState == STATE_INITIAL):
		if (GamePlay):
			GameState = STATE_START
			StateCounter = STATE_CYCLES_START

	elif (GameState == STATE_START):
		if (StateCounter == 0):
			GameState = STATE_PLAY
			StateCounter = STATE_CYCLES_PLAY
		else:
			StateCounter -= 1

	elif (GameState == STATE_PLAY):
		if (StateCounter == 0):
			if (ChoiceGreen == CHOICE_SCISSORS) :
				if (ChoiceRed == CHOICE_SCISSORS) :
					GameResult = RESULT_DRAW
				elif (ChoiceRed == CHOICE_PAPER) :
					GameResult = RESULT_GREEN
				elif (ChoiceRed == CHOICE_STONE) :
					GameResult = RESULT_RED
				elif (ChoiceRed == CHOICE_INVALID) :
					GameResult = RESULT_GREEN
			elif (ChoiceGreen == CHOICE_PAPER) :
				if (ChoiceRed == CHOICE_SCISSORS) :
					GameResult = RESULT_RED
				elif (ChoiceRed == CHOICE_PAPER) :
					GameResult = RESULT_DRAW
				elif (ChoiceRed == CHOICE_STONE) :
					GameResult = RESULT_GREEN
				elif (ChoiceRed == CHOICE_INVALID) :
					GameResult = RESULT_GREEN
			elif (ChoiceGreen == CHOICE_STONE) :
				if (ChoiceRed == CHOICE_SCISSORS) :
					GameResult = RESULT_GREEN
				elif (ChoiceRed == CHOICE_PAPER) :
					GameResult = RESULT_RED
				elif (ChoiceRed == CHOICE_STONE) :
					GameResult = RESULT_DRAW
				elif (ChoiceRed == CHOICE_INVALID) :
					GameResult = RESULT_GREEN
			elif (ChoiceGreen == CHOICE_INVALID) :
				if (ChoiceRed == CHOICE_SCISSORS) :
					GameResult = RESULT_RED
				elif (ChoiceRed == CHOICE_PAPER) :
					GameResult = RESULT_RED
				elif (ChoiceRed == CHOICE_STONE) :
					GameResult = RESULT_RED
				elif (ChoiceRed == CHOICE_INVALID) :
					GameResult = RESULT_VOID

			LEDResultState = True
			LEDResultStateGreen = True
			LEDResultStateRed = True
			StateCounter = STATE_CYCLES_RESULT
			ResultToggleCounter = RESULT_TOGGLE_COUNT

			GameState = STATE_RESULT

		else:
			StateCounter -= 1

	elif (GameState == STATE_RESULT):
		if (GamePlay):
			GameState = STATE_START
			StateCounter = STATE_CYCLES_START
		elif (StateCounter == 0):
			if (ResultToggleCounter == 0):
				LEDResultState = True
				if(ChoiceGreen == CHOICE_INVALID):
					LEDResultStateGreen = False
				if (ChoiceRed == CHOICE_INVALID):
					LEDResultStateRed = False
			else:
				ResultToggleCounter -= 1

				LEDResultState = not LEDResultState
				LEDResultStateGreen = not LEDResultStateGreen
				LEDResultStateRed = not LEDResultStateRed
				StateCounter = STATE_CYCLES_RESULT
		else:
			StateCounter -= 1

	if (GameState == STATE_INITIAL):
		LEDValues = False

	elif (GameState == STATE_START):
		LEDValues = True

	elif (GameState == STATE_PLAY):
		LEDValues = False

#	elif (GameState == STATE_RESULT):

#----------------------------------------------------------

def Do_Outputs():

	global LEDValues
	global GameState
	global StateCounter
	global GamePlay
	global ChoiceRed
	global ChoiceGreen
	global GameResult
	global LEDResultState
	global LEDResultStateGreen
	global LEDResultStateRed
	global ResultToggleCounter

	if (GameState == STATE_INITIAL) or (GameState == STATE_START) or (GameState == STATE_PLAY):
		if (LEDValues) :
			GPIO.output(LED_GREEN_SCISSORS, random.choice([True, False]))
			GPIO.output(LED_GREEN_PAPER, random.choice([True, False]))
			GPIO.output(LED_GREEN_STONE, random.choice([True, False]))
			GPIO.output(LED_RED_SCISSORS, random.choice([True, False]))
			GPIO.output(LED_RED_PAPER, random.choice([True, False]))
			GPIO.output(LED_RED_STONE, random.choice([True, False]))
			GPIO.output(LED_GREEN_RESULT, random.choice([True, False]))
			GPIO.output(LED_RED_RESULT, random.choice([True, False]))
		else:
			GPIO.output(LED_GREEN_SCISSORS, False)
			GPIO.output(LED_GREEN_PAPER, False)
			GPIO.output(LED_GREEN_STONE, False)
			GPIO.output(LED_RED_SCISSORS, False)
			GPIO.output(LED_RED_PAPER, False)
			GPIO.output(LED_RED_STONE, False)
			GPIO.output(LED_GREEN_RESULT, False)
			GPIO.output(LED_RED_RESULT, False)

	elif (GameState == STATE_RESULT):
		if (ChoiceGreen == CHOICE_SCISSORS) :
			GPIO.output(LED_GREEN_SCISSORS, LEDResultStateGreen)
			GPIO.output(LED_GREEN_PAPER, False)
			GPIO.output(LED_GREEN_STONE, False)
		elif (ChoiceGreen == CHOICE_PAPER) :
			GPIO.output(LED_GREEN_SCISSORS, False)
			GPIO.output(LED_GREEN_PAPER, LEDResultStateGreen)
			GPIO.output(LED_GREEN_STONE, False)
		elif (ChoiceGreen == CHOICE_STONE) :
			GPIO.output(LED_GREEN_SCISSORS, False)
			GPIO.output(LED_GREEN_PAPER, False)
			GPIO.output(LED_GREEN_STONE, LEDResultStateGreen)
		elif (ChoiceGreen == CHOICE_INVALID) :
			GPIO.output(LED_GREEN_SCISSORS, LEDResultStateGreen)
			GPIO.output(LED_GREEN_PAPER, LEDResultStateGreen)
			GPIO.output(LED_GREEN_STONE, LEDResultStateGreen)

		if (ChoiceRed == CHOICE_SCISSORS) :
			GPIO.output(LED_RED_SCISSORS, LEDResultStateRed)
			GPIO.output(LED_RED_PAPER, False)
			GPIO.output(LED_RED_STONE, False)
		elif (ChoiceRed == CHOICE_PAPER) :
			GPIO.output(LED_RED_SCISSORS, False)
			GPIO.output(LED_RED_PAPER, LEDResultStateRed)
			GPIO.output(LED_RED_STONE, False)
		elif (ChoiceRed == CHOICE_STONE) :
			GPIO.output(LED_RED_SCISSORS, False)
			GPIO.output(LED_RED_PAPER, False)
			GPIO.output(LED_RED_STONE, LEDResultStateRed)
		elif (ChoiceRed == CHOICE_INVALID) :
			GPIO.output(LED_RED_SCISSORS, LEDResultStateRed)
			GPIO.output(LED_RED_PAPER, LEDResultStateRed)
			GPIO.output(LED_RED_STONE, LEDResultStateRed)

		if (GameResult == RESULT_RED) :
			GPIO.output(LED_GREEN_RESULT, False)
			GPIO.output(LED_RED_RESULT, LEDResultState)
		elif (GameResult == RESULT_GREEN) :
			GPIO.output(LED_GREEN_RESULT, LEDResultState)
			GPIO.output(LED_RED_RESULT, False)
		elif (GameResult == RESULT_DRAW) :
			GPIO.output(LED_GREEN_RESULT, LEDResultState)
			GPIO.output(LED_RED_RESULT, LEDResultState)
		elif (GameResult == RESULT_VOID) :
			GPIO.output(LED_GREEN_RESULT, LEDResultStateGreen)
			GPIO.output(LED_RED_RESULT, LEDResultStateRed)

#----------------------------------------------------------

def Delay_ms(msec):
	time.sleep(msec / 1000.0)

#----------------------------------------------------------

def Timing():
	Delay_ms(LED_INTERVAL_MSEC)

#----------------------------------------------------------

def main():
	Initialize()

	while(True):
		Get_Inputs()
		Decide()
		Do_Outputs()
		Timing()

#----------------------------------------------------------

LED_GREEN_SCISSORS = 8
LED_GREEN_PAPER = 10
LED_GREEN_STONE = 12

LED_RED_SCISSORS = 3
LED_RED_PAPER = 5
LED_RED_STONE = 7

LED_GREEN_RESULT = 21
LED_RED_RESULT = 19

SWITCH_GREEN_SCISSORS = 22
SWITCH_GREEN_PAPER = 24
SWITCH_GREEN_STONE = 26

SWITCH_RED_SCISSORS = 11
SWITCH_RED_PAPER = 13
SWITCH_RED_STONE = 15

SWITCH_PLAY = 23

CHOICE_INVALID = 0
CHOICE_SCISSORS = 1
CHOICE_PAPER = 2
CHOICE_STONE = 3

RESULT_GREEN = 0
RESULT_RED = 1
RESULT_VOID = 2
RESULT_DRAW = 3

STATE_INITIAL = 0
STATE_START = 1
STATE_PLAY = 2
STATE_RESULT = 3

LED_INTERVAL_MSEC = 20

STATE_CYCLES_START = 125
STATE_CYCLES_PLAY = 50
STATE_CYCLES_RESULT = 10

RESULT_TOGGLE_COUNT = 10

#----------------------------------------------------------

LEDValues = False

GameState = STATE_INITIAL

StateCounter = 0

GamePlay = False

ChoiceRed = 0
ChoiceGreen = 0

GameResult = 0

LEDResultState = False
LEDResultStateGreen = False
LEDResultStateRed = False

ResultToggleCounter = 0

#----------------------------------------------------------

main()

#----------------------------------------------------------
